local ScenarioUtils = import('/lua/sim/ScenarioUtilities.lua')
local ScenarioFramework = import( '/lua/ScenarioFramework.lua' )

local beatTime = 5

unites = {}

printf = function(text)
	PrintText(text,20,nil,5,'center') 		
end

function OnPopulate()

  ScenarioUtils.InitializeArmies()

end

function OnStart(self)

  for index,army in ListArmies() do
    SetAlliance( army, 'ARMY_9', 'Neutral')
    SetAlliance( army, 'ARMY_10', 'Ally')
    ScenarioFramework.AddRestriction(army, categories.UEF)
    ScenarioFramework.AddRestriction(army, categories.AEON)
    ScenarioFramework.AddRestriction(army, categories.CYBRAN)
    
    ScenarioFramework.RemoveRestriction(army, categories.ENERGYPRODUCTION)
  end
  
  --on supprime les d�gats des commandeurs
  local Commandeurs = GetUnitsInRect(ScenarioUtils.AreaToRect('ZONE'))
  if Commandeurs then
    for k,unit in Commandeurs do
      for i=1,unit:GetWeaponCount() do
        --unit:GetWeapon(i):ChangeDamage(0)
        --unit:GetWeapon(i):SetEnabled(false)
        
        --on les rend ausi rapide que des scoots
        unit:SetSpeedMult(3)
        unit:SetAccMult(3)
               
      end
		end
	end
  
  -- radar et pow gen invincible
  makeInvincible(CreateUnitHPR('ueb3104', 'ARMY_10', 126, 64, 128, 0,0,0))
  makeInvincible(CreateUnitHPR('ueb1301', 'ARMY_10', 130, 64, 128, 0,0,0))
  
  
  --PD T1 uef : 16 de chaque
  ajouter_unites('ueb2101',16)
  ajouter_unites('uab2101',16)
  ajouter_unites('urb2101',16)
  
  --PD T2 : 8 de chaque
  ajouter_unites('ueb2301',8)
  ajouter_unites('uab2301',8)
  ajouter_unites('urb2301',8)

  --powgen T1 : 4 de chaque
  ajouter_unites('urb1101',4)
  ajouter_unites('urb1101',4)
  ajouter_unites('urb1101',4)
  --powgen T2 : 1 de chaque
  ajouter_unites('urb1201',1)
  ajouter_unites('urb1201',1)
  ajouter_unites('urb1201',1)
  
  --energy storage, for overcharge, 4 de chaque
  ajouter_unites('urb1105',4)
  ajouter_unites('urb1105',4)
  ajouter_unites('urb1105',4)
  
  --arty T2 : 4 de chaque
  ajouter_unites('urb2303',4)
  ajouter_unites('urb2303',4)
  ajouter_unites('urb2303',4)
  
  

  --start main thread
	local mainThread = ForkThread(function()
		while true do
			Verif_Unites()
			WaitSeconds(beatTime)
		end
    end)
end

function Verif_Unites()
  for i,unite in unites do
    if unite.unit:IsDead() then
      if not GetUnitsInRect({x0=unite.posx-1, y0=unite.posy-1, x1=unite.posx+1, y1=unite.posx+1,}) then
        unite.unit=CreateUnitHPR(unite.bp, 'ARMY_9', unite.posx, 64, unite.posy, 0,0,0)
      end
    end
  end
end

function ajouter_unites(bp,nombre)
  for i=1,nombre do
    local unite = {unit = nil, posx = 0, posy = 0, bp = ''}
    unite.posx = Random(0,256)
    unite.posy = Random(0,256)
    --pour �viter les unit�s coll�es
    while GetUnitsInRect({x0=unite.posx-1, y0=unite.posy-1, x1=unite.posx+1, y1=unite.posx+1,}) do
      unite.posx = Random(0,256)
      unite.posy = Random(0,256)
    end
    unite.bp = bp
    unite.unit = CreateUnitHPR(bp, 'ARMY_9', unite.posx, 64, unite.posy, 0,0,0)  
    table.insert(unites,unite)
  end
end


makeInvincible = function(unit)		
	unit:SetDoNotTarget(true)
	unit:SetCanBeKilled(false)
	unit:SetCapturable(false)
	unit:SetReclaimable(false)
	unit:SetDoNotTarget(true)
	unit:SetMaxHealth(10000)
	unit:SetHealth(nil,10000)
	unit:SetRegenRate(10000)
end

